var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var cvs;
var myApp;
var MyApp = (function (_super) {
    __extends(MyApp, _super);
    function MyApp(htmlCvsElem) {
        var _this = this;
        _super.call(this, htmlCvsElem);
        this.MAX_NUM_OF_FIREWORKS = 7;
        this.update = function (time) {
            for (var i = 0; i < _this.fireworks.length; i++) {
                if (_this.fireworks[i].isActive()) {
                    if (_this.fireworks[i].update()) {
                        _this.explodeFlashIntensity += 10;
                    }
                }
                else {
                    _this.fireworks.splice(i, 1);
                }
            }
            if ((_this.fireworks.length < _this.MAX_NUM_OF_FIREWORKS) && Math.random() < 0.02) {
                _this.fireworks.push(new FireWork(_this.canvasMain.width, _this.canvasMain.height));
            }
        };
        this.draw = function (ctx, time) {
            ctx.save();
            if (_this.showExplosionFlash && (_this.explodeFlashIntensity > 0)) {
                ctx.save();
                ctx.fillStyle = Util.buildRgba(0x88, 0x88, 0x88, Math.min(1, _this.explodeFlashIntensity * 0.05));
                ctx.fillRect(0, 0, _this.getCanvasWidth(), _this.getCanvasHeight());
                _this.explodeFlashIntensity--;
            }
            for (var i = 0; i < _this.fireworks.length; i++) {
                _this.fireworks[i].display(ctx);
            }
            ctx.restore();
        };
        this.SetExplosionFlash = function (enabled) {
            _this.showExplosionFlash = enabled;
            _this.explodeFlashIntensity = 0;
        };
        this.setBackground("#000000");
        this.fireworks = new Array();
        this.fireworks.push(new FireWork(htmlCvsElem.width, htmlCvsElem.height));
        this.explodeFlashIntensity = 0;
        this.showExplosionFlash = true;
        this.FpsDrawFpsValue = true;
        this.FpsFillStyle = '#444444';
    }
    return MyApp;
})(GraphicsLoop);
function startButtonEvent() {
    myApp.startMainLoop();
}
function stopButtonEvent() {
    myApp.stopMainLoop();
}
function fullScreentButtonEvent() {
    myApp.setFullScreen();
}
function explodeFlashCheckBoxClickEvent() {
    myApp.SetExplosionFlash((document.getElementById('explodeFlashCheckbox')).checked);
}
window.addEventListener("load", function () {
    cvs = document.getElementById('cvs');
    myApp = new MyApp(cvs);
    var startButton = document.getElementById('startButton');
    startButton.addEventListener("click", startButtonEvent, false);
    var stopButton = document.getElementById('stopButton');
    stopButton.addEventListener("click", stopButtonEvent, false);
    var fullscreenButton = document.getElementById('fullscreenButton');
    fullscreenButton.addEventListener("click", fullScreentButtonEvent, false);
    var explodeFlashCheckbox = document.getElementById('explodeFlashCheckbox');
    explodeFlashCheckbox.addEventListener("click", explodeFlashCheckBoxClickEvent, false);
    myApp.setMaxAllowedFps(80);
    myApp.startMainLoop();
});
//# sourceMappingURL=App.js.map