var Particle2D = (function () {
    function Particle2D(xOrPos, yOrSpeed, acceleration) {
        var _this = this;
        this.displayFunction = null;
        this.update = function (time) {
            _this.Speed.addVec(_this.Acceleration);
            _this.Position.addVec(_this.Speed);
        };
        this.display = function (ctx) {
            if (_this.displayFunction) {
                _this.displayFunction.displayParticle(ctx, _this);
            }
            else {
                ctx.fillStyle = _this.GetColorRGBAString();
                ctx.fillRect(_this.Position.X - 1, _this.Position.Y - 1, 3, 3);
            }
        };
        this.SetRenderFunction = function (displayFunc) {
            _this.displayFunction = displayFunc;
        };
        this.SetColor = function (r, g, b, a) {
            _this.ColorR = r;
            _this.ColorG = g;
            _this.ColorB = b;
            _this.ColorA = a;
        };
        this.GetColorRGBAString = function () {
            return "rgba(" + _this.ColorR.toString() + ", " + _this.ColorG.toString() + ", " + _this.ColorB.toString() + ", " + _this.ColorA.toString() + ")";
        };
        if (typeof xOrPos == "number") {
            this.Position = new Vector2D(xOrPos, yOrSpeed);
            this.Speed = new Vector2D(0, 0);
            this.Acceleration = new Vector2D(0, 0);
        }
        else {
            this.Position = xOrPos;
            this.Speed = (yOrSpeed === undefined) ? new Vector2D(0, 0) : yOrSpeed;
            this.Acceleration = (acceleration === undefined) ? new Vector2D(0, 0) : acceleration;
        }
        this.ColorR = this.ColorG = this.ColorB = 255;
        this.ColorA = 1;
    }
    return Particle2D;
})();
//# sourceMappingURL=Particle2D.js.map