var Util = (function () {
    function Util() {
    }
    /**
     * Returns a random number between min (inclusive) and max (exclusive)
     * Taken from: https://stackoverflow.com/questions/1527803/generating-random-whole-numbers-in-javascript-in-a-specific-range
     */
    Util.getRandom = function (min, max) {
        return Math.random() * (max - min) + min;
    };
    /**
     * Returns a random integer between min (inclusive) and max (inclusive).
     * The value is no lower than min (or the next integer greater than min
     * if min isn't an integer) and no greater than max (or the next integer
     * lower than max if max isn't an integer).
     * Using Math.round() will give you a non-uniform distribution!
     * Taken from: https://stackoverflow.com/questions/1527803/generating-random-whole-numbers-in-javascript-in-a-specific-range
     */
    Util.getRandomInt = function (min, max) {
        var minInt = Math.ceil(min);
        var maxInt = Math.floor(max);
        return Math.floor(Math.random() * (maxInt - minInt + 1)) + minInt;
    };
    /**
     * Builds an rgba string
     */
    Util.buildRgba = function (r, g, b, a) {
        if (a === undefined) {
            return "rgba(" + r.toString() + ", " + g.toString() + ", " + b.toString() + ", 1)";
        }
        else {
            return "rgba(" + r.toString() + ", " + g.toString() + ", " + b.toString() + ", " + a.toString() + ")";
        }
    };
    Util.mapValRange = function (value, sourceStart, sourceEnd, destStart, destEnd) {
        var ratio = (value - sourceStart) / (sourceEnd - sourceStart);
        var result = ratio * (destEnd - destStart) + destStart;
        return result;
    };
    return Util;
})();
//# sourceMappingURL=Util.js.map